Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class PathExpression

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.PathExpression

All Implemented Interfaces:
  Serializable, SourceLocator, Container, ContextMappingFunction, EvaluableItem, SequenceIterable, InstructionInfoProvider

    public final class PathExpression

extends Expression
implements ContextMappingFunction

An expression that establishes a set of nodes by following relationships between nodes in the document. Specifically, it consists of a start expression which defines a set of nodes, and a Step which defines a relationship to be followed from those nodes to create a new set of nodes.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`PathExpression(Expression start, Expression step)` Constructor

Method Summary
`int` | `computeCardinality()` Determine the static cardinality of the expression
`int` | `computeDependencies()` Determine which aspects of the context the expression depends on.
`int` | `computeSpecialProperties()` Get the static properties of this expression (other than its type).
`void` | `display(int level, PrintStream out, Configuration config)` Diagnostic print of expression structure
`boolean` | `equals(Object other)` Is this expression the same as another expression?
`Expression` | `getFirstStep()` Get the first step in this expression.
`ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the items returned by this exprssion
`Expression` | `getLastStep()` Get the last step of the path expression
`Expression` | `getLeadingSteps()` Get a path expression consisting of all steps except the last
`Expression` | `getRemainingSteps()` Get all steps after the first.
`Expression` | `getStartExpression()` Get the start expression (the left-hand operand)
`Expression` | `getStepExpression()` Get the step expression (the right-hand operand)
`int` | `hashCode()` get HashCode for comparing two expressions
`boolean` | `isAbsolute(TypeHierarchy th)` Test whether a path expression is an absolute path - that is, a path whose first step selects a document node
`SequenceIterator` | `iterate(XPathContext context)` Iterate the path-expression in a given context
`Iterator` | `iterateSubExpressions()` Get the immediate subexpressions of this expression
`SequenceIterator` | `map(XPathContext context)` Mapping function, from a node returned by the start iteration, to a sequence returned by the child.
`Expression` | `optimize(Optimizer opt, StaticContext env, ItemType contextItemType)` Optimize the expression and perform type analysis
`Expression` | `promote(PromotionOffer offer)` Promote this expression if possible
`boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
`Expression` | `simplify(StaticContext env)` Simplify an expression
`PathExpression` | `tryToMakeAbsolute(TypeHierarchy th)` Test whether a path expression is an absolute path - that is, a path whose first step selects a document node; if not, see if it can be converted to an absolute path.
`Expression` | `typeCheck(StaticContext env, ItemType contextItemType)` Perform type analysis

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, checkPermittedContents, computeStaticProperties, doPromotion, effectiveBooleanValue, evaluateAsString, evaluateItem, getCardinality, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### PathExpression

    public PathExpression(Expression start,
                          Expression step)

  Constructor

  Parameters:
    `start` - A node-set expression denoting the absolute or relative set of nodes from which the navigation path should start.
    `step` - The step to be followed from each node in the start expression to yield a new node-set

Method Detail

### getStartExpression

    public Expression getStartExpression()

  Get the start expression (the left-hand operand)

### getStepExpression

    public Expression getStepExpression()

  Get the step expression (the right-hand operand)

### getItemType

    public final ItemType getItemType(TypeHierarchy th)

  Determine the data type of the items returned by this exprssion

  Specified by:
    `getItemType` in class `Expression`
  Parameters:
    `th` -
  Returns:
    the type of the step

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Simplify an expression

  Overrides:
    `simplify` in class `Expression`
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(StaticContext env,
                                ItemType contextItemType)
                         throws XPathException

  Perform type analysis

  Overrides:
    `typeCheck` in class `Expression`
  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### optimize

    public Expression optimize(Optimizer opt,
                               StaticContext env,
                               ItemType contextItemType)
                        throws XPathException

  Optimize the expression and perform type analysis

  Overrides:
    `optimize` in class `Expression`
  Parameters:
    `opt` - the optimizer in use. This provides access to supporting functions; it also allows different optimization strategies to be used in different circumstances.
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### promote

    public Expression promote(PromotionOffer offer)
                       throws XPathException

  Promote this expression if possible

  Overrides:
    `promote` in class `Expression`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Returns:
    if the offer is not accepted, return this expression unchanged. Otherwise return the result of rewriting the expression to promote this subexpression
  Throws:
    `XPathException` - if any error is detected

### iterateSubExpressions

    public Iterator iterateSubExpressions()

  Get the immediate subexpressions of this expression

  Overrides:
    `iterateSubExpressions` in class `Expression`
  Returns:
    an iterator containing the sub-expressions of this expression

### replaceSubExpression

    public boolean replaceSubExpression(Expression original,
                                        Expression replacement)

  Replace one subexpression by a replacement subexpression

  Specified by:
    `replaceSubExpression` in interface `Container`
  Overrides:
    `replaceSubExpression` in class `Expression`
  Parameters:
    `original` - the original subexpression
    `replacement` - the replacement subexpression
  Returns:
    true if the original subexpression is found

### computeDependencies

    public int computeDependencies()

  Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE

  Overrides:
    `computeDependencies` in class `Expression`
  Returns:
    the depencies, as a bit-mask

### computeSpecialProperties

    public int computeSpecialProperties()

  Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Overrides:
    `computeSpecialProperties` in class `Expression`

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality of the expression

### equals

    public boolean equals(Object other)

  Is this expression the same as another expression?

  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  get HashCode for comparing two expressions

  Overrides:
    `hashCode` in class `Object`

### getFirstStep

    public Expression getFirstStep()

  Get the first step in this expression. A path expression A/B/C is represented as (A/B)/C, but the first step is A

### getRemainingSteps

    public Expression getRemainingSteps()

  Get all steps after the first. This is complicated by the fact that A/B/C is represented as ((A/B)/C; we are required to return B/C

### getLastStep

    public Expression getLastStep()

  Get the last step of the path expression

### getLeadingSteps

    public Expression getLeadingSteps()

  Get a path expression consisting of all steps except the last

### isAbsolute

    public boolean isAbsolute(TypeHierarchy th)

  Test whether a path expression is an absolute path - that is, a path whose first step selects a document node

### tryToMakeAbsolute

    public PathExpression tryToMakeAbsolute(TypeHierarchy th)

  Test whether a path expression is an absolute path - that is, a path whose first step selects a document node; if not, see if it can be converted to an absolute path. This is possible in cases where the path expression has the form a/b/c and it is known that the context item is a document node; in this case it is safe to change the path expression to /a/b/c

  Returns:
    the path expression if it is absolute; the converted path expression if it can be made absolute; or null if neither condition applies.

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Iterate the path-expression in a given context

  Specified by:
    `iterate` in interface `SequenceIterable`
  Overrides:
    `iterate` in class `Expression`
  Parameters:
    `context` - the evaluation context
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### map

    public SequenceIterator map(XPathContext context)
                         throws XPathException

  Mapping function, from a node returned by the start iteration, to a sequence returned by the child.

  Specified by:
    `map` in interface `ContextMappingFunction`
  Parameters:
    `context` - The processing context. The item to be mapped is the context item identified from this context: the values of position() and last() also relate to the set of items being mapped
  Returns:
    a SequenceIterator over the sequence of items that the supplied input item maps to
  Throws:
    `XPathException`

### display

    public void display(int level,
                        PrintStream out,
                        Configuration config)

  Diagnostic print of expression structure

  Specified by:
    `display` in class `Expression`
  Parameters:
    `level` - indentation level for this expression
    `out` - Output destination

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.